% Created 2025-01-08 Wed 17:44
% Intended LaTeX compiler: pdflatex
\documentclass[bigger,aspectratio=169]{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\mode<beamer>{\usetheme{Madrid}}
\usepackage[style=authoryear,maxcitenames=1,url=false,eprint=false]{biblatex}
\usepackage{tikz}
\usepackage{pgfpages}
% \setbeameroption{show notes on second screen}
\usepackage{marvosym}
\usepackage{caption}
\usepackage{hyperref}
\usepackage{hyperxmp}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{positioning}
\usetikzlibrary{calc}
\usetikzlibrary{arrows}
\input{resources/colors}
\definecolor{mpievolbio_green}{RGB}{0,124,119}
\setbeamercolor*{frametitle}{fg=white,bg=MPGGreen}
\setbeamercolor*{section in head/foot}{fg=white,bg=MPGGreen}
\setbeamercolor*{date in head/foot}{fg=white,bg=MPGGreen}
\setbeamercolor*{author in head/foot}{fg=white,bg=MPGGreen}
\setbeamercolor*{title in head/foot}{fg=white,bg=MPGGreen}
\setbeamercolor{structure}{bg=MPGGreen}
\setbeamercolor{block title}{fg=white,bg=structure.bg}
\setbeamercolor{block body}{use=block title,bg=block title.bg!10}
\setbeamercolor{title}{fg=white,bg=MPGGreen}
\setbeamercolor{itemize item}{fg=MPGGreen}
\setbeamercolor{itemize subitem}{fg=MPGGreen}
\setbeamercolor{enumerate item}{fg=MPGGreen}
\setbeamercolor{enumerate subitem}{fg=MPGGreen}
\setbeamercolor{description item}{fg=MPGGreen}
\setbeamertemplate{itemize item}[circle]
\setbeamertemplate{itemize subitem}[circle]
\setbeamertemplate{itemize subsubitem}[circle]
\setbeamercolor{alerted text}{fg=MPGOrange,bg=MPGLightGreen}
\addbibresource{jabref.bib}
\captionsetup{labelformat=empty, font={tiny,rm,color=black}}
\AtEveryBibitem{\clearfield{issn}}
\AtEveryBibitem{\clearfield{url}}
\AtEveryBibitem{\clearfield{urldate}}
\hypersetup{pdfdate={2024-11-06}}
\usetheme{default}
\author{Carsten Fortmann-Grote\thanks{carsten.fortmann-grote@evolbio.mpg.de}}
\date{November 6 2024}
\title{Research Software Engineering for Reproducible High Performance Scientific Computing}
\title[RSE4HPC]{Research Software Engineering for Reproducible High Performance Scientific Computing}
\logo{\includegraphics[width=0.05\textwidth]{cc-by.png}\hspace{.02\textwidth}\hspace{.02\textwidth}\includegraphics[width=0.05\textwidth]{images/mpg_logo_FGgreen_BGalpha}}
\hypersetup{
 pdfauthor={Carsten Fortmann-Grote},
 pdftitle={Research Software Engineering for Reproducible High Performance Scientific Computing},
 pdfkeywords={good scientific practice, open science, software Development, snakemake, conda, containerization, apptainer, mpcdf, gwdg, python, bioinformatics, raxml, phylogeny, clonalframeml, pipeline},
 pdfsubject={Presentation at the Open Science Ambassoder Meeting, Berlin, Nov. 6-7 2024},
 pdfcreator={Emacs 28.2 (Org mode 9.7.4)}, 
 pdflang={English}}
\begin{document}

\maketitle
\section{Making change happen}
\label{sec:orga35af7a}
\begin{frame}[label={sec:orgb676f8c}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\note{
Making Open Science a reality is about change. Change of practices,
change of scientific culture, change of hierarchical organizations, change of
incentives, change of how science is done. I found the following representation
of the preconditions for change and their respective weight and importance in any cultural or societal setting very
instructive, the pyramid of change.}
\end{frame}
\begin{frame}[label={sec:orgd1aa513}]{The pyramid of change}
\begin{columns}
\begin{column}[t]{.48\columnwidth}
\begin{block}{Ingredients for change}
\begin{figure}[htbp]
\centering
\includegraphics[width=.9\linewidth]{images/COS_Culture_and_Behavior_Change_model_header.png}
\caption{\label{pyramid_of_change}Credits: \url{https://cos.gov}. See also \parencite{Robson2021}}
\end{figure}
\note<1>{Starting at the \alert{bottom}, to make the change to the advertised behaviour possible,
we first need an \alert{infrastructure} that supports this change. In scientific
computing, this means, we need \alert{openly accessible web services} where we can
expose our scientific artifacts according to the open science paradigm: \alert{The}
\alert{data, the results, and the procedures} (the code) how we get from the former to
the latter.

But this infrastructure not only has to be there, it has to be \alert{easy to use} so
the \alert{community can actually adopt} the new practices and turn them into a \alert{norm}.
\alert{Incentives and policies} - or carrots and sticks - raise the attractiveness of
change for those that are either hesitant or resistant. In any case, simply
setting a \alert{policy}, the top level, is as prone to failure as only providing the infrastructure.
All levels of the pyramid are essential but there are differences in how much
effort should go into developing each \alert{level} and how important each
of these \alert{levels} is to achieve the objective.}
\end{block}
\end{column}
\begin{column}[t]{.48\columnwidth}
\begin{block}<2->{Stakeholders}
\begin{itemize}
\item Policy \MVRightarrow{} Directors, President
\item Incentives \MVRightarrow{} Group leaders, science funding agencies, career pathway responsibles
\item \alert{\alert{Communities}} \MVRightarrow{} YOU (the OSAs)
\item UI/UX \MVRightarrow{} Technical infrastructure implementers, \alert{\alert{RSEs}},
\item Infrastructure \MVRightarrow{} IT, Libraries,
\end{itemize}
\note<2>{The different levels of the pyramid of course have different stakeholders. Policies are made (or rather approved) by
the leadership, the directors, the presidency. Incentives, I find this the most tricky one: Group leaders, science
funding agencies, career responsibles (whoever that is). The community, that's us here, that's you, the Open Science
Ambassadors. 
As a support scientist, I'm involved mainly in the Infrastructure, user interface and user experience as well as in
the policy sections. Accordingly, what I'll do now is to go through these elements and say a few words about how they are
or should be addressed. Let me begin with the Policies.}
\end{block}
\end{column}
\end{columns}
\end{frame}
\section{Policies}
\label{sec:orgd986586}
\begin{frame}[label={sec:orge5853c0}]{}
\begin{center}
\vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\end{frame}
\begin{frame}[label={sec:org1d664b9}]{MPGs Recommendations for Good Scientific Practice}
\begin{columns}
\begin{column}[t]{0.48\columnwidth}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[height=.6\textheight]{images/MPGRulesGoodScientificPractice-Frontpage.pdf}
\caption{\label{MPGRulesGoodScientificPractice}MPG Rules for Good Scientific Practice}
\end{figure}
\end{block}
\end{column}
\begin{column}[t]{0.48\columnwidth}
\begin{block}{}
\begin{itemize}
\item Constitutive (approved by Senate vote)
\item High level general rules and obligations
\item Complementary rules and implementation needed on institute/department/group level
\end{itemize}
\end{block}
\end{column}
\end{columns}
\note{We do not have an Open Science Policy but what we have is the Senat approved
"Rules of conduct for Good Scientific Practices". Open Science is not mentioned explicitely
but OS best practices are actually referenced:
open access publishing, preprint publishing, provision of
code and data. Also FAIR data principles are referenced as a guiding principle

The documents ambition to provide guidance for the entire MPS comes at the cost
of being generic. As such, it provides general principles but there is
definitely a need to derive concrete actions at the institutional and/or
departmental level. But also at the community level, guidance and concrete
recommendations are needed for example in the context of research software
engineering.}
\end{frame}
\section{User interfaces: Making it easy}
\label{sec:orgc3fc57b}
\begin{frame}[label={sec:orgcaf545a}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\note{
So this is the part about user interfaces, user experience and making things easy.
Following a workshop on Research Software Development in Plön in 2022, a
group of interested support scientists, IT staff, and representatives of central facilities,
realized that the rules of conduct for g.s.p. is rather vague on the topic of scientific software.
The term is used in numerous occasions but, similar to all other areas, the ordinary scientist will not find explicit guidance on how to actually enact the principles put forth.}
\end{frame}
\begin{frame}[label={sec:orga6e2402}]{Example where clarification is needed}
\begin{block}{Quote from the MPG Rules of G.S.P. p 40}
\begin{quotation} %% 
\emph{``The source code of publicly accessible software must be persistent, citable and documented.''}
\end{quotation}
\end{block}
\note{
As an example, let's look at the following quote.
Nothing to disagree about, that's for sure.}
\end{frame}
\begin{frame}[label={sec:orge40b37b},fragile]{ok, but how?}
 \begin{itemize}
\item How can I make Software freely and openly accessible?
\item How do I ensure my software is citable?
\item Are there requirements or recommendations for software documentation?
\item Which license should I use?
\item How can I archive software for long-term storage?
\item How do I obtain a persistent identifier for software?
\item Do I need a PID for the software as a whole, an individual release, a single library/file/function/line?
\item Which PID should I use?
\item Under which cirumstances should software \alert{\alert{not}} be made publicly available?
\end{itemize}
\note{
But how exactly? Reading this part, a series of questions immediately came to our minds.
\texttt{Read out the questions}
We felt there's a missing link between the high level Recommendations and the day-to-day business in the institutes and offices of researchers and research software engineers. So what we did then is
to go through the document, read each and every sentence and ask questions about how it is releated to RSE and what it means for RSE. What came out is a catalogue of what be believe could be frequently asked
questions. Of course we did not stop there but also set out to find some answers.}
\end{frame}
\begin{frame}[label={sec:org0f2258a}]{Frequently asked questions on Good Scientific Practice in Research Software Engineering}
\begin{columns}
\begin{column}[T]{.66\columnwidth}
\begin{block}{}
\begin{center}
\includegraphics[height=.67\textheight]{images/2024-10-21_11-09-56_screenshot.png}
\label{gwp-rse_screenshot}
\end{center}
\end{block}
\end{column}
\begin{column}[T]{.33\columnwidth}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[width=\textwidth]{images/QR-20241107-141907.png}
\caption{\url{https://s.gwdg.de/ck3fvp}}
\end{figure}
\end{block}
\end{column}
\end{columns}
\note{These questions and answers are now published at \url{https://gwp-rse-ff130b.pages.gwdg.de}. As a disclaimer, we do not regard this work
as done but in the spirit of good open science, we decided to go public already at a very early stage and we are expliticely interested
in any kind of feedback we may receive from potential visitors of the site. So, please feel welcome to visit the site, browse around, see if you
find answers to your questions or if you have questions we may not have considered yet. Another word of disclaimer, as of today, the site is only in
German, an English translation is underway.

The FAQs are split into 7 sections: Documentation, PIDs and Citation, Legal aspects, Repositories, Reproducibility, Safety and Ethics, and Training/Selftraining. For each section, one of us acts as
a caretaker, but ultimately, we all share the responsibility for the content. We eat our own dogfood in the sense that the development takes place entirely open (within the MPG) on the GWDG gitlab where
everyone should feel invited to contribute by opening a ticket in the issues or by opening a pull request.}
\end{frame}
\begin{frame}[label={sec:org632f2e7},fragile]{This talk is about reproducibility}
 \begin{block}{Reproducibility - Replicability - Repeatability}
\begin{description}
\item[Reproducibility] Same experimental setup, different team $\MVRightarrow$ same results
\item[Replicability] Different experimental setup, different team  $\MVRightarrow$ same results
\item[Repeatability] Same experimental setup, same team $\MVRightarrow$ same results
\end{description}
\fullcite{Antunes2024}
\end{block}
\begin{alertblock}<2->{What is "the same"?}
\begin{center}
Within statistical error bounds? \(\Leftrightarrow\)  bitwise identity
\end{center}
\end{alertblock}
\note{
Now, this talk is about reproducibility, so let's first define this term and delineate it against other, similar terms, in particular \texttt{replicability} and repeatability. In particular reproducibility and replicability are
often used in a synonymous fashion but turns out, they are really not synonymous. Since 2020, these definitions as stated by
the ACM (Association for Computing Machinery) have become the consensus:
Reproducibility is when the same artifacts (samples, raw data, code)
are used by a different group of people according to the implementation, protocols, and recipes of the original group to obtain the same scientific results .
Replicability is when a different group uses their own implementation or protocol or recipe to process the same samples and given only the processing steps to obtain the same results. Repeatability finally is when
the same group uses their method repeatedly on their artifacts to obtain the same results. Repeatability is at the level of the scientist or lab, reproducibility is at the level of a peer group, replicability is at
the level of the scientific community. It's not by chance, that the R in FAIR stands for Reproducibility, not Replicability.}
\end{frame}
\begin{frame}[label={sec:org8cd0378}]{The FAQs on reproducibility}
\begin{columns}
\begin{column}{.48\columnwidth}
\begin{block}{Reproducibility FAQ website}
\begin{center}
\includegraphics[height=0.6\textheight]{images/2024-10-21_14-34-50_screenshot.png}
\label{gwp-rse_repro_screenshot}
\end{center}
\end{block}
\end{column}
\begin{column}{.48\columnwidth}
\begin{block}{K. Hinsen \parencite{Hinsen2020}}
\begin{itemize}
\item All relevant input \alert{data} and source \alert{code} is \alert{inspectable}.
\item Verify results on a suitable \alert{computer of one's own choice}
\item \alert{Inspect} intermediate results, run code with \alert{modifications}, code analysis
\item Verify \alert{published executable} versions
\end{itemize}
\end{block}
\end{column}
\end{columns}
\note{
So what does our FAQ catalogue say about reproducibility? Our answers refer
mostly to Konrad Hinsen, who defines four criteria or "possibilities", when
scientific computing is reproducible: The possibility to inspect all input data
and source code, the possibility to verify the results on a computer and OS of
one's own choice, the possibility to inspect the inner workings of the code by
inspecting intermediate results, run the code with modifications or slightly
altered conditions, and finally, the possibility to verify the result by
rerunning the published executable version of the code. Now, with this in the
back of our heads, let's see which factors can come in the way of
reproducibility in scientific computing.}
\end{frame}
\section{Factors reducing reproducibility in scientific computing}
\label{sec:orgccd50ea}
\begin{frame}[label={sec:org3eae6e7}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\end{frame}
\begin{frame}[label={sec:org66d5dfe}]{Causes of reproducibility loss}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[width=.7\textwidth]{img/Slides/2024-10-22_18-04-47_screenshot.png}
\caption{\label{antunes2024_fig1}Reasons of reproducibility loss \parencite{Antunes2024}}
\end{figure}
\end{block}
\note{In a very recent review on the subject, Antunes and Hill discuss various factors reducing
reproducibility in Scientific Computing in general and more specifically in high performance computing
in terms of global factors and in terms of user dependent factors}
\end{frame}
\begin{frame}[label={sec:org9a48197},fragile]{Software Engineering}
 \begin{block}{Example: \parencite{Hinsen2018}}
\begin{onlyenv}<1>
\begin{verbatim}
import pandas

df = pandas.read_csv('data.csv', header=0, nrows=11, sep='\t')

print(df.head(2))
print(df.dtypes)
\end{verbatim}
\begin{verbatim}
   week                              hash
0     1  33a16844cddc264946b272a5c459e4be
1     2  a5125cc2f67e2fedc1b625dd506bf9ae
week     int64
hash    object
dtype: object
\end{verbatim}
\end{onlyenv}
\begin{onlyenv}<2>
\begin{verbatim}
import pandas

df = pandas.read_csv('data.csv', header=0, sep='\t')

print(df.head(2))
print(df.dtypes)
\end{verbatim}
\begin{verbatim}
  week                              hash
0    1  33a16844cddc264946b272a5c459e4be
1    2  a5125cc2f67e2fedc1b625dd506bf9ae
week    object
hash    object
dtype: object
\end{verbatim}
\end{onlyenv}
\begin{onlyenv}<3->
What's in the data:
\begin{center}
\begin{tabular}{rl}
week & hash\\
\ldots{} & \ldots{}\\
31 & f114846dfb7d280d608f54fde9eb5fb6\\
32 & 4ee85b69281f2b1c49458a91974dd467\\
- & -\\
34 & 7945103c5ba98b90b42b46a2081b9781\\
35 & 5c59eeba4dc4b9ac9372c98654788661\\
\ldots{} & \ldots{}\\
\end{tabular}
\end{center}
\end{onlyenv}
\begin{alertblock}<4>{}
But pandas won't tell you 
\end{alertblock}
\end{block}
\note{
Software engineering or rather the lack of software engineering skills can become a problem for example if high level libraries are used without a proper understanding of the inner workings as
this example by Hinsen illustrates. The pandas library in python is the de-facto standard for loading, cleaning, processing, and inspecting tabular data. Now, in the python spirit of dynamic typing,
pandas auto-guesses the type (int, float, string, \ldots{}) of data read e.g. from a csv file of comma separated values. Hence, a scientist may first load only a small fraction of the file, say the first 11 lines
to test their processing script and rely on the fact that for this data, all week numbers are integers.

But then, when loading the full dataset, the dtype of the week column inexplicably changes from "int" to "object". Would the average scientist know why this has changed and what consequences could be entailed? Inspecting
the datafile natively (in a text editor) reveals that line 34 has missing data. The dtype of column "week" is therefore heterogeneous and pandas represents such a case by dtype "object" without any feedback to the user.

Clearly, this goes somewhat against the argument in favor of 3rd party libraries made above. The conclusion can only be that good data science skills must be in the portfolio of today's scientist and should
be integral part of scientists education.}
\end{frame}
\begin{frame}[label={sec:org75729ca}]{Testing}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{itemize}
\item assert code runs as expected after each code change
\item language specific unittest libraries
\item github actions, gitlab-ci
\end{itemize}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{description}
\item[unit testing:] test each function produces expected output for given input
\item[regression testing:] test repeatability on reference data
\item[integration testing:] test all components work together
\end{description}
\end{block}
\end{column}
\end{columns}
\note{Testing is the key to ensure long term usability and basically amounts to verify
all the assumptions made regarding the various component of your code. Ideally,  tests always
predate the implementation, meaning first write the test, then the implementation,
but I'm also aware that this is sometimes hard to
realize, in particular in the exploratory phase where ideas quickly change and
tests would have to be continuously modified. Testing is sometimes
differentiated into unit testing, testing individual components (functions,
classes) to work correctly to capture if a new implementation of a function or
changes in a dependent library still yield correct results, regression testing
to check for correct functioning of the entire software, e.g. by comparing the
final output to a reference, and integration testing which tests if all parts
and dependencies are still compatible and function together.}
\end{frame}
\begin{frame}[label={sec:org37d5d6b}]{Software environment}
\begin{block}{}
\begin{itemize}
\item Software programs are never monolithic but have dependencies
\item Changes in dependant libraries
\item New versions may become incompatible with main code / with other libraries
\item What works on one system is not guaranteed to work on another system
\item Portability across operating systems and hardware often limited
\item Possible solution: Rely entirely on closed source frameworks (Geneious, mathematica, matlab) \parencite{Hinsen2020}
\end{itemize}
\end{block}
\note{
The vast abundance of scientific software is not monolithic but rather relies on a plethora of numerical, statistical, graphics and other libraries. Not only
are these easy to use but in many cases also provide the best option in terms of performance because they are developed by professional software engineers. Anyone who has ever tried to
implement a fast fourier transform or a matrix diagonalization and not use fftw or MKL will know what I'm talking about. Nevertheless, also professionally managed software libraries have bugs, and
if bugs are fixed, new versions are released. For various reasons, library B may not be compatible anymore with the new version of library A. But even if all libraries are still compatible, the new version of code A
may use a ever so slightly different memory allocation in one of the algorithms needed to produce that one figure in the last paper and now
the precise number does not come out anymore. Maybe nothing to worry about but in terms of bitwise reproducibility, it sure is. Also, one set of versions may work on one system but is far from guaranteed
to work on all systems and operating systems.}
\end{frame}
\begin{frame}[label={sec:org2a47c7b}]{Software environment}
\begin{block}{}
\begin{itemize}
\item OS specific package managers (apt, yum, brew, \ldots{})
\item language specific package managers (pip, CRAN, gems, npm, \ldots{})
\item language agnostic package managers (conda, mamba, \ldots{})
\end{itemize}
\end{block}
\note{
Specifying the software environment: Numerous ways to do this, ranging operating system level package management such
as apt or rpm on linux, via language specific package management like pip for python, maven for java, CRAN or Bioconductor for R to OS and language
agnostic package managers like conda. Usually, dependencies and their specific version if not build tag or listed in a structured metadata file in plain
text, json, or yaml format.}
\end{frame}
\begin{frame}[label={sec:org5fbfdee}]{Workflows}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{itemize}
\item data processing performed in multiple steps
\item iterative
\item multiple branches
\item amplifies the problem of version matching
\item additional challenge for documentation and logging
\end{itemize}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[height=.5\textheight]{images/2024-10-23_16-46-56_screenshot.png}
\caption{\label{workflow}\parencite{Antunes2024}}
\end{figure}
\end{block}
\end{column}
\end{columns}
\note{
At a higher level, the need to combine multiple codes in a workflow or processing pipeline reiterates the need for proper documentation. Managing the flow of data across many different
programs, potentially with need for reformatting, parallel execution of several pipeline branches, orchestration of pipeline execution on high performance computing clusters and batch farms make utilization
of a modern workflow management system indispensable.}
\end{frame}
\begin{frame}[label={sec:orga6be719}]{Workflow management}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{itemize}
\item manage input/output streams between processes
\item map workflow nodes to compute request on HPC/HTC systems
\item managage package dependencies
\end{itemize}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{itemize}
\item make
\item snakemake
\item nextflow
\item galaxy
\item CWL
\item knime, orange
\end{itemize}
\end{block}
\end{column}
\end{columns}
\note{
Conducting the flow of data between multiple applications, including parallel
and asynchronous processing is greatly facilitated by a workflow managing system
such as snakemake (which builds on the ideas of the make utility to track the
state and create/modify timestamps of files or directories) or nextflow or more
graphical systems like galaxy, knime or orange. CWL is an attempt to provide a kind
of programming language as a common basis for higher level frameworks.}
\end{frame}
\begin{frame}[label={sec:org030f2be}]{Archiving}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[height=.7\textheight]{images/lg65bfqncy431.jpg}
\caption{@quentinnuk@reddit.com}
\end{figure}
\end{block}
\note{So how do we now preserve the entire stack consisting of our software, its
dependencies, the workflow, documentation, maybe even raw and processed data?
There are essentially three options. The first option is the most reliable,
store away the entire hardware with all installed dependencies and the code
itself, ready to be re-executed when plugged into a socket and switched on. Can
be a little expensive, especially if extra measures to mitigate corruption of
storage devices are envisaged, such as low temperatures or radiation shielding.
Not very practical.}
\end{frame}
\begin{frame}[label={sec:org5d9bbab}]{Archiving}
\begin{block}{Containers and Virtual Machines}
\begin{figure}[htbp]
\centering
\includegraphics[width=.8\textwidth]{images/vm_vs_cont.png}
\caption{\parencite{Antunes2024}}
\end{figure}
\end{block}
\note{The two other options are containerization and virtual machines. A virtual
machine is an entire operating system in which the application runs as one of
its processes. A software called hypervisor takes care of resource sharing
between multiple VMs and resides directly on the host hardware. This has the
advantage that legacy code that runs only in some obscure legacy operating
system can still be executed. Downside is that virtual machines are quite
resource hungry, carry significant overhead (the operating system) that draw on
the host systems resources and hence are not the premier choice if performance
is a concern. Containers on the other hand can be seen as lightweight virtual
machines running inside the host operating system. Containerized applications
package all software dependencies in one easily transferable entity (image).
Images can easily be combined as layers, something that is not possible with
virtual machines. This flexibility and modularity have greatly boosted the
usability of software archiving solutions with Docker certainly being the most
widely known system, but due to security issues with docker, Singularity and its
successor Apptainer have become dominant in the context of scientific computing
on HPC platforms, where ordinary users have no superuser privileges.}
\end{frame}
\section{Measures to improve reproducibility in scientific computing}
\label{sec:org635aed0}
\section{Factors reducing reproducibility in HPC}
\label{sec:orgf6a6189}
\begin{frame}[label={sec:org0a19a37}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\end{frame}
\begin{frame}[label={sec:orgc03ba2f}]{Causes of reproducibility loss}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[width=.7\textwidth]{img/Slides/2024-10-22_18-04-47_screenshot.png}
\caption{\label{antunes2024_fig1}Reasons of reproducibility loss \parencite{Antunes2024}}
\end{figure}
\end{block}
\end{frame}
\begin{frame}[label={sec:org69a1485}]{Parallel computation}
\begin{block}{}
\begin{itemize}
\item order of execution can be nondeterministic
\item load balancing
\item multithreading
\item network topology
\item \MVRightarrow compensation algorithms \(\Leftrightarrow\) overhead
\end{itemize}
\end{block}
\note{
HPC systems achieve their high performance because they support efficient
execution of parallel applications with high data transfer rates between
processes as leveraged for example by the message passing interface MPI. And
this bring in some additional things to consider when reproducibility is needed.
Namely, the order in which parallel processing steps are executed becomes
non-deterministic. It depends on things like load balancing (how are hardware
resources shared among processes?) or the network topology, where not all
processes have the same physical distance and therefore communication speeds may
differ. That being said, there are solutions to address this specific problem, such
as record and replay, where the exact order of execution is recorded at runtime such that it can
be re-executed in exactly the same order again, to achieve bitwise reproducibility. But as always, this comes
at the cost of significant overhead and can reduces the performance significantly, such that it should really only
be used if bitwise reproducibility is mandated and only for the final run to be published.}
\end{frame}
\begin{frame}[label={sec:org131e566},fragile]{Parallel computing and order of execution}
 \begin{block}{Example: non-associativity}
\begin{onlyenv}<1>
\begin{eqnarray*}
1\cdot 10^{-3} + 1 - 1 & = & 0.001\\
                       & = & (1\cdot 10^{-3} + 1) - 1 \\
                       & = &  1\cdot 10^{-3} + (1 - 1)
\end{eqnarray*}
\end{onlyenv}
\begin{onlyenv}<2->
\begin{verbatim}
a = (pow(10, -3) + 1) - 1
b = pow(10, -3) + (1 - 1)

print(f"a={a}\t\tb={b}")
\end{verbatim}

\begin{verbatim}
a=0.0009999999999998899		b=0.001
\end{verbatim}
\end{onlyenv}
\end{block}
\begin{alertblock}<3>{}
\begin{itemize}
\item Exascale: 10\textsuperscript{18} FLOPS \MVRightarrow accumulation of errors
\item countermeasures are expensive in performance
\end{itemize}
\end{alertblock}
\note{
\begin{onlyenv}<1>
So why does it matter in which order my instructions are executed?
Let's look at a simple but very instructive example, the addition of three floating point numbers.
The result of this expression should be 0.001, no computer needed
\end{onlyenv}
\begin{onlyenv}<2>
Unfortunately, at least in python,
the order matter. In the first case, we evaluate the first some first and then subtract 1, in the second case, we first perform
the subtraction and then add 10 to the power -3. The results are not the same.
\end{onlyenv}
\begin{onlyenv}<3>
The difference is only of the order 10 to the power -15, so
you might say, why worry? But now, if we run a code on the latest exascale HPC system with 10 to the power 18 floating point operations  per second, these
errors actually will sum up to significant errors and this is a problem. To be fair, compiled languages may suffer less from this problem.
\end{onlyenv}}
\end{frame}
\begin{frame}[label={sec:org26a414a}]{Random number generation}
\begin{block}{}
\begin{itemize}
\item many HPC applications rely on random numbers
\begin{itemize}
\item MonteCarlo, Probabilistic Programming (Bayesian inference, Maximum Likelihood methods)
\end{itemize}
\item Random numbers are usually pseudorandom numbers, reoccurence with period
\item must document the PRNG initialization
\item TRNGs oppose bitwise reproducibility
\item overlapping streams will detriment reproducibility due to unpreserved order of execution
\item List of good PRNGS are listed in Antunes2024, see also Hill et al. 2013, 2015
\end{itemize}
\end{block}
\note{
Random number generation is another area that can be impacted by non-deterministic order of execution on parallel compute architectures. That's because random numbers are actually pseudo-random numbers, meaning their distribution
may be stochastic but the order in which they are produced is deterministic. Which is good for reproducibility but vulnerable if executed on HPC due to the above. Again, record and replay provides a way out but with the additional overhead. In any case
exposing the initial state of the PRNG as something the user can configure and avoiding true random number generators is good practice. In addition on HPC systems, different processes should use different parts of the PRNG's periodic stream to avoid having
to utilize record and replay.}
\end{frame}
\begin{frame}[label={sec:orgd7f3f78}]{Optimization}
\begin{onlyenv}<1>
\begin{block}{}
\begin{itemize}
\item modern CPUs offer various optimizations:
\begin{itemize}
\item fused multiply-add (FMA)
\begin{itemize}
\item perform a*b + c in one step at hardware level
\item implementations vary among architectures, leading to varying number of
parallel executions, execution order varies
\end{itemize}
\item advanced vector extensions (AVX)
\begin{itemize}
\item AVX register holds multiple single or double precision floats. Again,
number of held units varies depending on AVX size (256, 512, \ldots{})
\item aggressive optimization will detriment reproducibility
\parencite{Ludwig2019}.
\end{itemize}
\item Tensor cores (e.g. on GPUs)
\end{itemize}
\end{itemize}
\end{block}
\note<1>{
Another source of non-deterministic execution can be aggressive optimization.
Again, we have the tradeoff between performance and reproducibility. What is
optimization: Modern computer architectures feature register memory large enough
to expose multiple floating point numbers at once to the processing unit,
enabling SIMD (single instruction multiple data) parallelism, more than one
float can be processed at once, or MISD (multiple instructions single data)
parallelism, e.g. fused mulitply-add. Tensor cores (GPUs) can be seen as a
scaled up version of such a CPU enabling SIMD at millionfold parallelization.

The problem is that aggressive optimization such xAVX with dynamic data alignment
makes the order of operations non-deterministic and this can lead to a loss of
bitwise reproducibility. Thomas Ludwig from the German Climate Compute Center has
illustrated this fact convincingly in a 2019 paper on reproducibility in HPC, I will recapitulate
his finding here:}
\end{onlyenv}
\begin{onlyenv}<2-3>
\begin{center}
ICON simulation for H$_2$O vapor column (kg/m$^2$) after \parencite{Ludwig2019}
\end{center}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}<2-3>{O2, no vectorization (10:30 min) deterministic}
\begin{center}
\includegraphics[width=.6\textwidth]{img/Factors_reducing_reproducibility_in_HPC/2024-10-24_11-05-42_screenshot.png}
\end{center}
\end{block}
\end{column}
\note<2-3>{
This graph shows a climate model result for the water vapor column in an area of Germany as computed by the ICON climate model which is developed by
the MPI for Meteorology and the German Weather Service. Color coded is the water vapor column measured in kg per square meter, x is geographic latitude, y is
geographic altitude, the water vapor density is integrated over the vertical axis. In this case, the code was compiled with the moderate O2 optimization flag which
does not switch on vectorization.}
\begin{column}[t]{.49\columnwidth}
\begin{block}<3>{O3 with vectorization (8:41 min) deterministic}
\begin{center}
\includegraphics[width=.6\textwidth]{img/Factors_reducing_reproducibility_in_HPC/2024-10-24_11-07-54_screenshot.png}
\end{center}
\end{block}
\end{column}
\end{columns}
\note<3>{
The second graph shows the same simulation starting from the exact same initialization but the code was compiled with more aggressive optimization using
vectorization and other tricks. Qualitatively, both results look similar but definitely not the same. At a given point in the simulation grid, the data can vary by
multiple factors between the two simulations. Note that taken individually, both simulations are exactly reproducibly, doing the same run with or without
vectorization will yield the bitwise identical result.}
\end{onlyenv}
\begin{onlyenv}<4>
\begin{center}
ICON simulation for H$_2$O vapor column (kg/m$^2$) after \parencite{Ludwig2019}
\end{center}
\begin{block}{O3 xAVX, 4 independent runs (not deterministic)}
\begin{center}
\includegraphics[height=.6\textheight]{img/Factors_reducing_reproducibility_in_HPC/2024-10-24_11-18-22_screenshot.png}
\end{center}
\end{block}
\note<4>{
That changes when even more aggressive optimization is switched on including so-called dynamic data alignment, an advanced vectorization technique. Now the order
of execution depends on what other processes run on the same hardware and 4 identically initialized runs yield different results, bitwise reproducibly is lost.}
\end{onlyenv}
\end{frame}
\begin{frame}[label={sec:org87a3f8b}]{Hardware heterogeneity}
\begin{block}{}
\begin{itemize}
\item HPC farms often combine numerous hardware stacks with variations in CPU architecture, cache size, vectorization size.
\item Partitions often include these various node types
\item added heterogeneity in GPU equipped nodes
\item due to above mentioned reasons, will lead to different results and non-bitwise reproducibility
\end{itemize}
\end{block}
\note{
I'll quickly pass over hardware heterogeneity in HPC systems as another source of indeterminism. Only the very advanced compute clusters are truely homogeneous
meaning all compute nodes are exact clones of each other in terms of CPU, memory, network etc. Many systems combine various hardware versions, architectures and sometime vendors
which, for all the above reasons add another source of indeterminism.}
\end{frame}
\begin{frame}[label={sec:orgf4b9d18}]{Silent errors}
\begin{onlyenv}<1>
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{itemize}
\item spontaneous bit flips in magnetic storage devices
\item alpha particles and other (cosmic) radiation
\item error rates: some 10\textsuperscript{4} per billion device hours per Mbit, over 8\% of DIMMs experience this error per year
\item temperature dependent
\item not limited to memory, can also occur in CPUs
\item smaller CPUs (<4nm) quantum effects, tunneling
\end{itemize}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{figure}[htbp]
\centering
\includegraphics[width=0.5\textwidth]{img/Factors_reducing_reproducibility_in_HPC/2024-10-26_22-50-17_screenshot.png}
\caption{from xkcd:378}
\end{figure}
\end{block}
\end{column}
\end{columns}
\note<1>{
I don't want to close this section without mentioning also this last but to me
as a one time physicst the most interesting source of indeterminism, nature
itself. Even if we had a perfectly homogenous system with controlled order of
execution at every level of optimization, physics would still get in our way.
Studies have shown that charged particles from geological or cosmic radiation
once in a while cause bitflips in magnetooptical storage media and even on CPUs.
The error rates are certainly small, of the order 10 to the power 4 per billion
device hours per Mbit}
\end{onlyenv}
\begin{onlyenv}<2>
\begin{block}{}
\begin{itemize}
\item \parencite{Dixit2021}: 2*3 may be reported as 5 not 6 and error may pass unnoticed
\item NSF Frontier Exascale cluster 8.7 million cores, mean time before failure is only a few hours
\end{itemize}
\end{block}
\note<2>{
, but again, on exascale computers with 10 to the power 18 floating point operations per second, the so-called mean time until failure
comes down into the few hours regime, so after a few hours computation on an
exascale system, we have to expect a bitflip somewhere which under certain
hardware configurations can make the simple operation of 2*3 be reported as 5,
not as 6.}
\end{onlyenv}
\end{frame}
\section{A small investigation of reproducibility in High Throughput Bioinformatics}
\label{sec:org5ebf67d}
\begin{frame}[label={sec:orgc7f3ad3}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\note{
Finally, I want to present a small experiment. In the experiment I try to follow
the recommendations for reproducible research software engineering in HPC as good
as possible and then evaluate how reproducible the results really are.}
\end{frame}
\begin{frame}[label={sec:org5e8c721},fragile]{The science}
 \begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{Inference of recombination events in closely related bacterial strains}
\begin{itemize}
\item Microbes reproduce asexually
\item Diversity through mutation at cell division
\item "simple" ancestral trees
\item Horizontal gene transfer: Influx of external DNA (phages, plasmids, lysed cells)
\item Correct phylogenetic trees for recombination events
\end{itemize}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
\begin{onlyenv}<1>
\begin{figure}[htbp]
\centering
\includegraphics[height=.5\textwidth]{img/A_small_investigation_of_reproducibility_in_High_Throughput_Bioinformatics/2024-10-27_23-26-34_screenshot.png}
\caption{dreamstime.com:196348166}
\end{figure}
\note<1>{The use case is a rather standard bioinformatic analysis of closely related
bacterial genomes. Evolutionary microbiologists are interested in finding the
most probable ancestral tree by comparing bacterial genomes or genetic
sequences. The standard procedure involves two steps of data processing: Alignment of sequences
finding the most probably sequence of edits by which one sequence is converted into the other sequence,
which gives rise to a distance matrix (how far, in a
particular sequence distance metric) each genome is away from all other genomes.
This distance matrix is then clustered and an inheritance tree is calculated via
maximum likelihood or Bayesian inference. This procedure assumes that all
differences in the genome sequences are due to spontaneous mutations in
otherwise clonal and asexually reproducing organisms. But this ignores that
there is something called horizontal gene transfer: Horizontal gene transfer
summarizes multiple processes by which genes can migrate between non-sexually
reproducing organisms, e.g. mediated by bacterial viruses, so-called phages.}
\end{onlyenv}
\begin{onlyenv}<2>
ClonalFrameML: Inference of genetic recombination
\begin{figure}[htbp]
\centering
\includegraphics[height=.5\textheight]{img/A_small_investigation_of_reproducibility_in_High_Throughput_Bioinformatics/2024-10-27_23-29-56_screenshot.png}
\caption{Didelot2015}
\end{figure}
\note<2>{These processes, also referred to a genetic recombination events, are not
accounted for by the phylogenetic inference methods. Currently, there are a few
methods to reconstruct the likelihood of recombination from the alignment and
the tree computed without assuming recombination. One of these methods is
ClonalFrameML. ClonalFrameML is a Bayesian inference algorithm that basically
produces a probability for recombination events having happened in total and per
genome.}
\end{onlyenv}
\begin{onlyenv}<3>
{\footnotesize
\begin{enumerate}
\item Whole genome alignment (\texttt{Mauve})
\item Core genome identification (\texttt{stripSubsetLCBs})
\item Reformat alignments (\texttt{perl})
\item Clean alignments (\texttt{grep}, \texttt{sed})
\item Phylogenetic tree (\texttt{RaxML})
\item Inference of recombination (\texttt{ClonalFrameML})
\item Plot results (\texttt{R})
\end{enumerate}
}
\note<3>{I start from 20 sequences of bacterial genomes from
closely related strains of the species \emph{Pseudomonas fluorescens}. The alignment
is done by a tool called \texttt{progressiveMauve}, which, unlike other codes, is able
to infer genetic rearrangements, not just point mutations. The alignment is then cleaned up, filtered, and
reformatted using specialized filter tools and a small pipeline that combines various unix commands and a perl script.
Then, a maximum-likelihood inference tool called RaXML infers the most likely phylogeny before both the alignment and
the phylogeny are fed into the ClonalFrameML algorithm which produces, besides others, a text file with the mean
and standard deviations of the posterior distributions of the model that expresses the likelihood of recombination occurring
at a given nucleotide position in the aligned genomes.}
\end{onlyenv}
\end{block}
\end{column}
\end{columns}
\end{frame}
\begin{frame}[label={sec:orgfaa2673}]{ClonalFrameML results}
\begin{onlyenv}<1>
\begin{block}{Posterior mean and variance for parameters of the recombination model}
{\footnotesize
\begin{center}
\begin{tabular}{lrr}
Parameter & Posterior Mean & Posterior Variance\\
\hline
R/theta & 0.1 & 4.1e-07\\
1/delta & 0.03 & 1.6e-08\\
nu & 0.1 & 6.2e-08\\
\end{tabular}
\end{center}
}
\end{block}
\end{onlyenv}
\note{
We ran the pipeline, and I'll show you the results which basically mean that there is only little recombination happening in these
lineages. So far so good. Now, I got a bit curious because we ran the same pipeline on a few computers and got some differences. Not so
much difference that it would make a qualitatively different results but yet the differences where larger (2 orders of magnitude)
than what the posterior distributions indicate. Ok, so let's try to make this a reproducible as possible and follow best practices
for research software engineering.}
\end{frame}
\begin{frame}[label={sec:org743feeb},fragile]{Software environment}
 \begin{block}{\texttt{environment.yml}}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{verbatim}
channels:
  - nodefaults
  - bioconda
  - conda-forge
dependencies:
  - python=3.12
  - snakemake>=8.20
  - biopython>=1.74
  - clonalframeml>=1.13
...
\end{verbatim}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{verbatim}
...
  - pandas
  - perl>=5.24
  - raxml>=8.2.12
  - phylip>=3.697
  - newick_utils>=1.6
  - r-base>=4.1
  - r-ape
  - r-phangorn
  - perl-bioperl>=1.7.8
\end{verbatim}
\end{column}
\end{columns}
\end{block}
\note{
The software environment is encoded in a yaml file to be consumed by the conda package manager. Note that here I specify the exact version of
each package but not the build tag to make it transferrable to other operating systems.
The aligner, \texttt{progressiveMauve} is not included because the
version available on conda did not work with the rest of the codes and I used the version available on the Debian package archive.
Regarding the software environment,
So it becomes clear that multiple pieces of software need to be installed on the system. I used conda to resolve all dependencies and
version requirements, here is a glance at the environment definition file.}
\end{frame}
\begin{frame}[label={sec:org2ce83c9},fragile]{The pipeline}
 \begin{block}{\texttt{Snakefile}}
\begin{columns}
\begin{column}[t]{.49\columnwidth}
{\tiny
\begin{verbatim}
from glob import glob
gzstrains = glob("../genomes/*.fn.gz")
strains = [fngz.replace(".fn.gz", "") for fngz in gzstrains]
fnstrains = [os.path.join('genomes', os.path.basename(st)+".fn") for st in strains]

rule decompress:
    input:
        expand("{gzstrain}", gzstrain=gzstrains)
    output:
        expand("{fnstrain}", fnstrain=fnstrains)
    shell:
        "gunzip -k ../genomes/*.fn.gz && mv ../genomes/*.fn genomes/"

rule mauve_align:
    input:
        expand("{fnstrain}", fnstrain=fnstrains)
    output:
        "out/01-alignment/alignment.xmfa",
        "out/01-alignment/alignment.xmfa.bbcols",
        "out/01-alignment/alignment.xmfa.backbone"
    shell:
        "progressiveMauve --output {output[0]} {input}"

...
\end{verbatim}
}
\end{column}
\begin{column}[t]{.49\columnwidth}
{\tiny
\begin{verbatim}
...
rule raxml_tree:
    input:
        "out/05-clean_strainnames/alignment.fasta"
    output:
        "out/06a-raxml/parsimony.nwk",
        "out/06a-raxml/raxml.log",
        "out/06a-raxml/result.txt",
        "out/06a-raxml/info.txt",
        "out/06a-raxml/best_tree.nwk"
    threads: 24
    shell:
        "raxmlHPC-PTHREADS -T {threads}  -s {input} -m GTRGAMMAI -p 1 -n raxml && "
        "mv -v RAxML_parsimonyTree.raxml out/06a-raxml/parsimony.nwk; "
        "mv -v RAxML_log.raxml out/06a-raxml/raxml.log; "
        "mv -v RAxML_result.raxml out/06a-raxml/result.txt; "
        "mv -v RAxML_info.raxml out/06a-raxml/info.txt; "
        "mv -v RAxML_bestTree.raxml out/06a-raxml/best_tree.nwk"
rule cfml_analyze:
    input:
        "out/06a-raxml/best_tree.nwk",
        "out/05-clean_strainnames/alignment.fasta"
    output:
        "out/07-cfml/cfml.em.txt",
        "out/07-cfml/cfml.importation_status.txt",
        "out/07-cfml/cfml.labelled_tree.newick",
        "out/07-cfml/cfml.ML_sequence.fasta",
        "out/07-cfml/cfml.position_cross_reference.txt"
    shell:
        "ClonalFrameML {input} cfml && "
        "mv -v cfml.*.* out/07-cfml/"

rule cfml_plots:
    params:
        cfml_base = "out/07-cfml/cfml"
    input:
        "out/07-cfml/cfml.em.txt",
        "out/07-cfml/cfml.importation_status.txt",
        "out/07-cfml/cfml.labelled_tree.newick",
        "out/07-cfml/cfml.ML_sequence.fasta",
        "out/07-cfml/cfml.position_cross_reference.txt"
    output:
        "out/07-cfml/genome_tree_heatmap.pdf"
    shell:
        "../src/cfml_results.R {params.cfml_base} && " 
        "mv {params.cfml_base}.cfml.pdf {output}"
\end{verbatim}
}
\end{column}
\end{columns}
\end{block}
\note{
The workflow itself is defined in snakemake. It consists of the seven steps outlined above, defined in a Snakemake file. Note how
output of one step becomes input in the next step.}
\end{frame}
\begin{frame}[label={sec:orga08c3e8},fragile]{The results}
 \begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{Output files}
\begin{verbatim}
$> ls -1 out
01-alignment/
02a-stripLCBs/
02b-stripGaps/
03-concat/
04-ambig_replace/
05-clean_strainnames/
06a-raxml/
07-cfml/
\end{verbatim}
\end{block}
\end{column}
\end{columns}
\note{One virtue of using snakemake or any other workflow manager is that output becomes neatly organized in separate directories according
to the specified output paths in the snakefile. No need to create and clean these directories, snakemake takes care of everything.}
\end{frame}
\begin{frame}[label={sec:orgb21e653},fragile]{The archive}
 \begin{columns}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
{\tiny
\begin{verbatim}
Bootstrap: docker
From: debian:12.7-slim

Stage: build

%files
  $PWD/environment.yml environment.yml
  $PWD/Snakefile Snakefile
  
%post
 apt update
 apt upgrade -y
 apt install -y progressivemauve curl
 apt install -y curl
 curl -L -O "https://github.com/conda-forge/miniforge...
 bash Miniforge3-$(uname)-$(uname -m).sh -b
 . /root/miniforge3/bin/activate
 mamba env create -n compbactgenomics --file environment.yml
\end{verbatim}
}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{block}{}
{\tiny
\begin{verbatim}
%test
 #!/usr/bin/bash

 which progressiveMauve
 which stripSubsetLCBs
 which perl
 which raxmlHPC
 which ClonalFrameML
 which Rscript

 . /root/miniforge3/bin/activate compbactgenomics
 timestamp=$(date +%Y-%m-%dT%H%M%S)
 snakemake -np --directory $timestamp cfml_plots

%runscript
 #!/usr/bin/bash

 . /root/miniforge3/bin/activate compbactgenomics
 timestamp=$(date +%Y-%m-%dT%H%M%S)
 snakemake --directory $timestamp -c all cfml_plots
\end{verbatim}
}
\end{block}
\end{column}
\end{columns}
\note{All components, the environment, build instructions, a test, and the command to run the entire pipeline are then
integrated in an Apptainer definition file or 'recipe'. Again, this has two benefits, the entire environment becomes easily shareable
across compute platforms and operating systems \alert{and} the file size of a container is small compared to a complete conda environment directory tree thanks
to efficient compression in Apptainer.}
\end{frame}
\begin{frame}[label={sec:org15a4e88},fragile]{Experiment setup}
 \begin{columns}
\begin{column}{.49\columnwidth}
\begin{block}{Available compute infrastructures}
\begin{description}
  \item[deepbio] Single node server
  \item[GWDG SCC] GWDG HPC Cluster
  \item[MPCDF Raven] MPCDF HPC Cluster
\end{description}
\end{block}
\end{column}
\begin{column}{.49\columnwidth}
\begin{block}{Single run}
\tiny{
\begin{verbatim}
#!/bin/bash
#SBATCH -p medium               # 'medium' queue
#SBATCH -N 1                    # 1 Node
#SBATCH -n 1                    # 1 task
#SBATCH -c 24                   # 24 CPUs per task
#SBATCH --mem 24G               # 24 GB

#SBATCH -t 12:00:00             # 12hrs
#SBATCH --mail-type=ALL         # Send all mails
#SBATCH --out job.%j.out        # Write stdout to job.<job-id>.out
#SBATCH --err job.%j.err        # Write errors to job.<job-id>.err
 
module load apptainer           # Load apptainer module

# Run default runscript
apptainer run --bind /local,/user,/home,/scratch  app.sif 
\end{verbatim}
}
\end{block}
\end{column}
\end{columns}
\note{The systems I ran my little experiment on are three different computer systems: A desktop workstation in my office, the SCC Cluster in Göttingen,
and the Raven cluster at the MPCDF in Munich. On all systems, I issued a SLURM job with the following parameters: The job runs on a single node, I reserve
24 CPUs to be consumed by the threaded phylogeny inference code RaXML and a moderate amount of memory. Each run takes about 12 hours to complete. All systems
support execution of apptainer images as ordinary users, no superuser powers required but a few directories have to mounted manually and he exact paths
differ of course between the three systems, I'm showing here only the example for the SCC at GWDG.}
\end{frame}
\section{Results}
\label{sec:org95d3a16}
\begin{frame}[label={sec:orgbbf05f8},fragile]{}
 \begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\note{In principle, and this was my maybe naive expectation, it should now become very easy to achieve the same results
in different compute environments. I did not expect bitwise reproducibility for the simple reason that the legacy codes I use (notably \texttt{progressiveMauve})
do not allow to initialize the PRNG, nor did I employ any kind of record and replay method. What I did expect though is that the variability in results
are distributed within the error margin of the predicted posterior distributions from the Bayesian estimators. In other words, I expected the variance
in my computed data to be smaller than the variance of the posterior distributions. That however, was not the case as I will now show in the results:}
\end{frame}
\begin{frame}[label={sec:orgb7570c5},fragile]{Results I}
 \begin{block}{3 runs, launched manually}
\begin{center}
\includegraphics[width=.8\textwidth]{images/results_3pilotruns.pdf}
\end{center}
\end{block}
\begin{alertblock}{}
\begin{itemize}
\item Inconsistent across clusters
\item 2/3 points agree on given cluster
\end{itemize}
\end{alertblock}
\note{As a pilot experiment, I executed three jobs .
All three jobs were manually by submitting the same job script three times and there was only ever one job running at any time. Then I looked at
the output from \texttt{ClonalFrameML} and plot the resulting global parameters that indicate the probability for recombination to have happened. I did not like what I saw
because the numbers differed both between computer systems and also for a given system, there was some variance.}
\end{frame}
\begin{frame}[label={sec:orge4e933f},fragile]{Results II}
 \begin{block}{\textasciitilde{}30 runs, launched from a shell loop}
\begin{center}
\includegraphics[width=.8\textwidth]{images/results_20241007.pdf}
\end{center}
\end{block}
\begin{alertblock}{}
\begin{itemize}
\item Inconsistent across clusters
\item Identical results on Raven
\item GWDG results split in two sets
\end{itemize}
\end{alertblock}
\note{I then went on and launched approx. 30 jobs on the two HPC systems Raven and SCC, this time running the \texttt{sbatch} command in a for loop. Why am I mentioning this? Well,
it seems to have made a difference. As you see, on Raven, all of the new results nicely agree and yield the same value for all 30 runs. On the SCC, the results
somehow split into two fractions. Just to make sure, the variance is again larger than the predicted variance of the posterior distributions.}
\end{frame}
\begin{frame}[label={sec:org1c0bfef}]{Results III}
\begin{block}{\textasciitilde{}30 more runs, launched from a shell loop}
\begin{center}
\includegraphics[width=.8\textwidth]{images/results_20241008.pdf}
\end{center}
\end{block}
\begin{alertblock}{}
\begin{itemize}
\item Inconsistent across clusters
\item Identical results on Raven
\item GWDG results split in three sets
\item Multiple sets on deepbio
\end{itemize}
\end{alertblock}
\note{The same experiment, 30 jobs launched in a for loop was repeated two days later and the same qualitative picture emerges. The data on the SCC now
splits into three fractions, two majority fractions and one small fractions of just two points. The two majority fractions coincide with the ones from the previous
batch experiment.}
\end{frame}
\begin{frame}[label={sec:orgdcb75da}]{Results IV}
\begin{block}{All runs}
\begin{center}
\includegraphics[width=.8\textwidth]{images/results_allsets.pdf}
\end{center}
\end{block}
\begin{alertblock}{}
\begin{itemize}
\item Inconsistent across clusters
\item two outliers on Raven
\item split sets on GWDG, deepbio
\end{itemize}
\end{alertblock}
\note{Putting it all together, it remains to be stated that
1.) On a given server, the results spread across a domain that is large against the predicted posterior variance. The raven system at least gives consistent
results for all runs submitted in batch mode.
2.) Results are very much not reproducible when compared among the different compute systems.
3.) The data are discretely distributed, not continuously as would be expected from prng effects or other noise impacts.}
\end{frame}
\begin{frame}[label={sec:org65ca7a4}]{Takeaways}
\begin{block}{Despite following best practices}
\begin{itemize}
\item Variation between and within 3 compute services
\item Discretely distributed results
\item Not consistent with inferred posterior distributions
\item MPCDF Raven produces identical results if jobs launched
\end{itemize}
\end{block}
\begin{alertblock}{Maybe it's just me, but \ldots{}}
\ldots{} how can we expect researchers to achieve reproducible HPC
if a dedicated service scientist can't get it right?
\end{alertblock}
\note{Now, what does this mean? Of course, I cannot rule out that I committed some stupid mistake that messed up the results. Possible, that
the bifurcating behaviour observed on some systems is caused by some kind of let's call it instability in the algorithm. Still, why do the
results differ so much across different computer systems? Again, I cannot control the random number generator, but I would have expected a more
evenly distributed results set than these discrete spikes. So let's assume for a moment, there was a way to achieve fully reproducible results or
at least results that are consistent with the inferred posterior distributions. This raises another and I dare to say in the context of this
workshop more interesting question: If a dedicated support scientist who's job it is to make computational stuff work can't figure out how to
get it right, then how on earth can we expect scientists, PhD students fighting to get their thesis done in time, PostDocs struggling to get a paper out so
they can apply for the next grant, to achieve reproducible computing?}
\end{frame}
\section{Backmatter}
\label{sec:org73d2fcc}
\begin{frame}[label={sec:orgfb7b4bc}]{Summary}
\begin{block}{}
\begin{itemize}[<+->]
\item Reproducibility in (high performance) computing is hard to achieve
\item Local and centralized service facilities provide numerous infrastructures and services
\item "Make it easy" requires more efforts
\item Good Scientific Practice requires expert level research software engineering skills
\end{itemize}
\end{block}
\note{In summary I believe it's fair to say that reproducibility in computing,
especially but not exclusively in high performance computing, is not an easy
task. Things have gotten a lot better than maybe 10 or even 20 years ago but
we're still a long fetch from a work environment and culture where
reproducibility. In particular, the level of support and the provided
infrastructure locally at the institutes but maybe more importantly the
centrally provided services are top notch. We have access to some of the world
finest compute infrastructures without even having to apply for compute time (up
to a certain degree). But I'd also say that the point about "Making it easy"
requires more effort. As I may have demonstrated, leaving it to the scientists
is asking for a lot given the current state of affairs.


How to address this? This now brings us to the second part of this "workshop"
and now it's your turn: What I want to invite you to do for the next 15-30
minutes or so is to use your laptop, tablet or smartphone add your questions (or
answers). What are YOUR questions regarding Good Scientific Practice, in general
but also with respect to Software Engineering and or for High Performance
Computing? How, in your institute, in your group, in your own projects do you
deal with software engineering, with knowledge transfer, with proper usage of
computing infrastructure?}
\end{frame}
\begin{frame}[label={sec:org8e9a71f}]{Acknowledgements}
\begin{block}{Many thanks to \ldots{}}
{\small
\begin{itemize}
\item My colleagues at the MPI-EvolBio and directory Paul Rainey for continued support of these and other activities
\item MPCDF and GWDG for outstanding support
\item Yves Grossmann, Michael Franke, David Walter, Stephan Janosch, Maximilian Funk, Andreas Wagner, Jens Saak, Jürgen Gremmels, Kristian Ullrich
and everyone else who contributed to the RSE FAQ project.
\item The organizers of this workshop for the kind invitation and hospitality
\item You for your attention and patience
\end{itemize}
}
\end{block}
\end{frame}
\section{Workshop}
\label{sec:org3b03b55}
\begin{frame}[label={sec:org54881f6}]{}
\begin{center} \vspace*{\fill}\Huge\insertsection\vspace*{\fill}
\end{center}
\note{And now to the fun part: With all the information thrown at you, I'd like to get something back. I want
to hear your questions regarding research software engineering, good scientific practices, high performance computing.
And of course your answers: How are these things handled at your institute? Are there policies, infrastructures,
cultures, communities to advance open science practices in general and in software engineering in particular.}
\end{frame}
\begin{frame}[label={sec:org3373aab}]{Your input, please \ldots{}}
\begin{columns}
\begin{column}{.49\columnwidth}
\begin{block}{Open}
\begin{center}
\includegraphics[height=.5\textheight]{images/QR-20241105-160249.png}
\end{center}
\url{https://s.gwdg.de/nsn5WN}
\end{block}
\end{column}
\begin{column}[t]{.49\columnwidth}
\begin{itemize}
\item Add your questions (15 minutes)
\item Add your answers (15 minutes)
\end{itemize}
\end{column}
\end{columns}
\note{So what I propose to those interested is you go to the website linked here and spend the next 15 minutes by noting down
your questions. After 15 minutes, we'll spend again 15 minutes to think about answers. Whereever you feel you have
information to share, please do so. The pads are structured in the same way as our FAQ website and indeed, my intention
is to incorporate your input into the website in the following days or weeks. So, your turn now!}
\end{frame}
\section{References}
\label{sec:orgc448800}
\section*{References}
\printbibliography
\end{document}
